#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "gd/gd.h"
#include "gd/gdfontg.h"
#include "gd/gdfonts.h"

#define XMAX    560
#define YMAX    300

static char WAKU[] = {"/home/k-wada/program/ondo-test/monlog2gif/gif/waku.gif"};

static FILE *in, *inimg;
static FILE *out;
static gdImagePtr im_in, im_out, im_tmp;
static char *monthname[] = {"January", "February", "March", "April", "May", "June", "July",
                       "August", "September", "October", "November", "December"};
static char monthstring[16];

/* Y $B<4(B $B$N@8@.(B */
void axis_y(gdImagePtr im_out, int max_y, int step, char *para_name)
{
  int offset_d = 50;  /* $B2<E@%*%U%;%C%HCM(B ($B%i%$%s(B)*/
  int offset_dd = 50; /* $B2<E@%*%U%;%C%HCM(B ($B<4L>(B)*/
  int offset_l = 10;  /* $B:8$+$i$N%*%U%;%C%HCM(B ($B<4L>(B)*/
  int offset_ll = 60; /* $B:8$+$i$N%*%U%;%C%HCM(B ($B%i%$%s(B)*/
  int color_draw;     /* $B<4?'$O%0%l%$(B */
  int width = 1;      /* $B<4$NI}(B */
  int max_x = XMAX;   /* X$B<4$N:GBgCM(B */
  int hlinecolor, green;
  int stepv, i;
  int y_zero;
  char *temp[] = {"-10", "  0", " 10", " 20", " 30",  " 40"};
  color_draw = gdImageColorAllocate(im_out, 50, 50, 50);
  hlinecolor = gdImageColorAllocate(im_out, 200, 200, 200);
  green = gdImageColorAllocate(im_out, 0, 255, 0);
  y_zero = max_y - offset_d;
  gdImageStringUp(im_out, gdFontGiant, offset_l, max_y - 80, para_name, color_draw);
  gdImageLine(im_out, offset_ll, y_zero, offset_ll, 10,  color_draw);
  stepv = y_zero;
  i = -1;
  while (i++ < 5) {
    gdImageLine(im_out, offset_ll - 3 , stepv, offset_ll + 3, stepv,  color_draw);
    gdImageString(im_out, gdFontSmall, offset_dd - 18, stepv - 5, temp[i], color_draw);
    if (i == 3) {
      gdImageLine(im_out, offset_ll + 3 , stepv, max_x - 10, stepv,  green);
    } else {
      gdImageLine(im_out, offset_ll + 3 , stepv, max_x - 10, stepv,  hlinecolor);
    }
    stepv -= step;
  }
}

/* X $B<4(B $B$N@8@.(B */
void axis_x(gdImagePtr im_out, int max_y, int step, char *para_name, char *now, char *ddate)
{
  int offset_d = 50;  /* $B2<E@%*%U%;%C%HCM(B ($B%i%$%s(B)*/
  int offset_dd = 50; /* $B2<E@%*%U%;%C%HCM(B ($B<4L>(B)*/
  int offset_l = 10;  /* $B:8$+$i$N%*%U%;%C%HCM(B ($B<4L>(B)*/
  int offset_ll = 60; /* $B:8$+$i$N%*%U%;%C%HCM(B ($B%i%$%s(B)*/
  int color_draw;     /* $B<4?'$O%0%l%$(B */
  int red;
  int width = 1;      /* $B<4$NI}(B */
  int max_x = XMAX;   /* X$B<4$N:GBgCM(B */
  int stepv, i;
  int y_zero;
  char *time[] = {" ", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15",\
		    "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29",\
		      "30", "31", " "};
  red = gdImageColorAllocate(im_out, 255, 50, 50);
  color_draw = gdImageColorAllocate(im_out, 50, 50, 50);
  y_zero = max_y - offset_d;
  gdImageLine(im_out, offset_ll, y_zero, max_x - 10, y_zero, color_draw);
  gdImageString(im_out, gdFontGiant, 200, max_y - 20, para_name, color_draw);
  stepv = offset_ll;
  i = -1;
  while (i++ < 31) {
    gdImageLine(im_out, stepv , y_zero + 3, stepv, y_zero - 3, color_draw);
    gdImageString(im_out, gdFontSmall, stepv -5 , max_y - 40 , time[i], color_draw);
    if (i == atoi(now)) {
      /* gdImageLine(im_out, stepv , y_zero, stepv, 10, red); */
    }
    stepv += step;
  }
  gdImageString(im_out, gdFontGiant, 100, 20, ddate, red );
}

/* $B29EY$NI=<((B */
void draw_ondo(gdImagePtr im_out, int i, int jikan, double ondoh, double ondol, int drawflag)
{
  int offset_d = 50;  /* $B2<E@%*%U%;%C%HCM(B ($B%i%$%s(B)*/
  int offset_dd = 50; /* $B2<E@%*%U%;%C%HCM(B ($B<4L>(B)*/
  int offset_l = 10;  /* $B:8$+$i$N%*%U%;%C%HCM(B ($B<4L>(B)*/
  int offset_ll = 60; /* $B:8$+$i$N%*%U%;%C%HCM(B ($B%i%$%s(B)*/
  int red;           /* $B@V(B */
  int blue;           /* $B<4?'$O%V%k!<(B */
  int yellow;           /* $B2+?'(B */
  int width = 1;      /* $B<4$NI}(B */
  int max_x = XMAX;   /* X$B<4$N:GBgCM(B */
  int max_y = YMAX;   /* Y$B<4$N:GBgCM(B */
  int black;
  int stepv;
  int stepx = 15;      /* $B%9%F%C%W(B x */
  int stepy = 40;      /* $B%9%F%C%W(B y */
  int point_yh = 0;
  int point_yl = 0;
  int y_zero;
  static  int point_yo = 0;
  static  int point_io = 0;
  static  int point_flag = 0;
  red = gdImageColorAllocate(im_out, 255, 0, 0);
  blue = gdImageColorAllocate(im_out, 0, 0, 255);
  yellow = gdImageColorAllocate(im_out, 0, 255, 255);
  black = gdImageColorAllocate(im_out, 0, 0, 0);
  y_zero = max_y - offset_d;
  point_yh = (y_zero - stepy) - (ondoh * 4);
  point_yl = (y_zero - stepy) - (ondol * 4);
  /* $BBGE@$N$_(B */
  gdImageArc(im_out, (jikan * stepx) + offset_ll, point_yh, 6, 6, 0, 360, red);
  gdImageArc(im_out, (jikan * stepx) + offset_ll, point_yl, 6, 6, 0, 360, blue);
  gdImageLine(im_out, (jikan * stepx) + offset_ll, point_yl, (jikan * stepx) + offset_ll, point_yh, yellow);
  point_io = (jikan * stepx) + offset_ll;
}

int main(int argc, char *argv[])
{
  time_t now;
  struct tm *tmstruct;
  gdImagePtr brush;
  int white, red;
  int background, hot, cool;
  gdPoint points[3];
  char *hour[10];
  char *day[10];
  char *month[10];
  char *ddate[10];
  char ondoh[32], ondol[32];
  char jikan[32];
  int i, j, k, drawflag, ch;
  int tmp, flag;
  int mode;

  /* $B8=:_;~4V$rF~<j(B */
  time(&now);
  tmstruct = localtime(&now);

  /* $B=PNO%$%a!<%8%5%$%:(B*/
  /* Create output image, 128 by 128 pixels. */
  im_out = gdImageCreate(XMAX, YMAX); 
  
  /* Set transparent color. */
  white = gdImageColorAllocate(im_out, 255, 255, 255);
  gdImageColorTransparent(im_out, white);
  
  /* $B?'(B */
  background = gdImageColorAllocate(im_out, 240, 240, 240);
  hot = gdImageColorAllocate(im_out, 255, 230, 230);
  cool = gdImageColorAllocate(im_out, 230, 230, 255);
  red = gdImageColorAllocate(im_out, 255, 0, 0);


/*  in = fopen("/home/k-wada/bin/ondo/meisei.gif", "rb"); */
  in = fopen("/usr/local/ondo/bin/meisei.gif", "rb");
  im_in = gdImageCreateFromGif(in);
  fclose(in);
  /*                                 dx  dy  sx sy  dw   sh  sw  sh */
/*  gdImageCopyResized(im_out, im_in, 200, 10, 0, 0, 174, 42, 174, 42); */

  /* Rectangle */
  gdImageLine(im_out, 0, YMAX, 0, 0, background);
  gdImageLine(im_out, 0, YMAX, XMAX, YMAX, background);
  gdImageLine(im_out, XMAX, YMAX, XMAX, 0, background);
  gdImageLine(im_out, 0, 0, XMAX, 0, background);
  gdImageFilledRectangle(im_out, 61, 52, 540, 210, hot);
  gdImageFilledRectangle(im_out, 61, 211, 540, 250, cool);
  /* Flood fill */
  gdImageFill(im_out, 1, 1, background);
  
  /* $B29EY(B Y $B<4IA2h(B */
  axis_y(im_out, YMAX, 40, "Temperature (deg.)");
  
  /* $B29EY(B X $B<4IA2h(B */
  sprintf(hour[0], "%02d", tmstruct->tm_hour);
  sprintf(day[0], "%02d", tmstruct->tm_mday);
/*  sprintf(ddate[0], "%02d/%02d", tmstruct->tm_mon + 1, tmstruct->tm_mday); */
  sprintf(monthstring, "%s", monthname[tmstruct->tm_mon]); 

  axis_x(im_out, YMAX, 15, "Days ", day[0], monthstring);

  /* $B%G!<%?%U%!%$%k$NF~NO(B ($B#1J8;z$E$DFI$_9~$`(B)*/
  in = fopen(argv[1], "r");
  drawflag = k = j = i = 0;
  mode = 0;
  while((ch = fgetc(in)) != EOF) {
    switch(ch) {
    case '\n':
      /* LOW */
      ondol[i++] = '\0';
      fflush(stdout);
      draw_ondo(im_out, k, atoi(jikan), atof(ondoh), atof(ondol), drawflag);
      k++;
      mode = 0;
      break;
    case ' ':
      switch(mode) {
      case 0:
	break;
      case 1:
	jikan[i++] = '\0';
	break;
      case 2:
	ondoh[i++] = '\0';
	break;
      case 3:
	break;
      }
      mode += 1;
      i = 0;
      break;
    default:
      switch(mode) {
      case 0:
	break;
      case 1:
	/* DAY */
	jikan[i++] = (char)ch;
	break;
      case 2:
	/* HIGH */
	ondoh[i++] = (char)ch;
	break;
      case 3:
	/* LOW */
	ondol[i++] = (char)ch;
	break;
      }
    }
  }
  drawflag = 1;
  draw_ondo(im_out, k, atoi(jikan), atof(ondoh), atof(ondol), drawflag);
  close(in);

  in = fopen(WAKU, "rb");
  im_tmp = gdImageCreateFromGif(in);
  fclose(in);
  /*                                 dx  dy  sx sy  dw  dh  sw  sh */
  gdImageCopyResized(im_tmp, im_out, 15, 70, 0, 0, 560, 300, 560, 300);

  /* GIF $B%U%!%$%k=q$-=P$7(B */
  gdImageInterlace(im_tmp, 1);
  out = fopen(argv[2], "wb");
  gdImageGif(im_tmp, out);
  fclose(out);
  gdImageDestroy(im_in);
  gdImageDestroy(im_out);
  gdImageDestroy(im_tmp);
  return 0;
}
